Newest packages not installable on Debian

Hi there,

it looks like a recent update switched new Debian/Ubuntu packages to using zstd compression: Let’s take a look at https://download.jitsi.org/stable/lua-cjson_2.1.0.10-jitsi1_amd64.deb that was updated yesterday (2022-09-20):

~/Downloads$ ar tv lua-cjson_2.1.0.10-jitsi1_amd64.deb 
rw-r--r-- 0/0      4 Sep 20 21:27 2022 debian-binary
rw-r--r-- 0/0   1017 Sep 20 21:27 2022 control.tar.zst
rw-r--r-- 0/0  21306 Sep 20 21:27 2022 data.tar.zst

This means that the package can only be used on Ubuntu. Trying to install or unpack that package on Debian yields this error:

dpkg-deb: error: archive 'lua-cjson_2.1.0.10-jitsi1_amd64.deb' uses unknown compression for member 'control.tar.zst', giving up

Zstd compression is an Ubuntu-only feature. For more information, you can refer to:

  • Debian Bug 892664
  • A Stack Exchange answer: unix.stackexchange .com /a/ 699008 (new user restrictions prevent me from posting more than 2 links)

To ensure that packages remain usable on Debian, you’ll have to use a method of compression supported by Debian’s dpkg (such as xz).

3 Likes

I can confirm this. Using jitsi under debian since ~ 1 year. Every ugrade worked until 20.09.2022.

Summary
root@xxx:~# apt list --upgradable
Listing... Done
lua-basexx/stable 0.4.1-jitsi1 all [upgradable from: 0.3-2.1]
lua-cjson/stable 2.1.0.10-jitsi1 amd64 [upgradable from: 2.1.0+dfsg-2.1]
root@xxx:~# apt upgrade
Reading package lists... Done
Building dependency tree... Done
Reading state information... Done
Calculating upgrade... Done
The following packages will be upgraded:
  lua-basexx lua-cjson
2 upgraded, 0 newly installed, 0 to remove and 0 not upgraded.
Need to get 26.8 kB of archives.
After this operation, 105 kB of additional disk space will be used.
Do you want to continue? [Y/n] y
Get:1 https://download.jitsi.org stable/ lua-basexx 0.4.1-jitsi1 [4,284 B]   
Get:2 https://download.jitsi.org stable/ lua-cjson 2.1.0.10-jitsi1 [22.5 kB] 
Fetched 26.8 kB in 1s (24.1 kB/s)
dpkg-deb: error: archive '/var/cache/apt/archives/lua-basexx_0.4.1-jitsi1_all.deb' uses unknown compression for member 'control.tar.zst', giving up
Traceback (most recent call last):
  File "/usr/share/apt-listchanges/DebianFiles.py", line 124, in readdeb
    output = subprocess.check_output(command)
  File "/usr/lib/python3.9/subprocess.py", line 424, in check_output
    return run(*popenargs, stdout=PIPE, timeout=timeout, check=True,
  File "/usr/lib/python3.9/subprocess.py", line 528, in run
    raise CalledProcessError(retcode, process.args,
subprocess.CalledProcessError: Command '['dpkg-deb', '-f', '/var/cache/apt/archives/lua-basexx_0.4.1-jitsi1_all.deb', 'Package', 'Source', 'Version', 'Architecture', 'Status']' returned non-zero exit status 2.

The above exception was the direct cause of the following exception:

Traceback (most recent call last):
  File "/usr/bin/apt-listchanges", line 323, in <module>
    main(config)
  File "/usr/bin/apt-listchanges", line 104, in main
    pkg = DebianFiles.Package(deb)
  File "/usr/share/apt-listchanges/DebianFiles.py", line 358, in __init__
    parser.readdeb(self.path)
  File "/usr/share/apt-listchanges/DebianFiles.py", line 127, in readdeb
    raise RuntimeError(_("Error processing '%(what)s': %(errmsg)s") %
RuntimeError: Error processing '/var/cache/apt/archives/lua-basexx_0.4.1-jitsi1_all.deb': Command '['dpkg-deb', '-f', '/var/cache/apt/archives/lua-basexx_0.4.1-jitsi1_all.deb', 'Package', 'Source', 'Version', 'Architecture', 'Status']' returned non-zero exit status 2.
dpkg-deb: error: archive '/var/cache/apt/archives/lua-basexx_0.4.1-jitsi1_all.deb' uses unknown compression for member 'control.tar.zst', giving up
dpkg: error processing archive /var/cache/apt/archives/lua-basexx_0.4.1-jitsi1_all.deb (--unpack):
 dpkg-deb --control subprocess returned error exit status 2
dpkg-deb: error: archive '/var/cache/apt/archives/lua-cjson_2.1.0.10-jitsi1_amd64.deb' uses unknown compression for member 'control.tar.zst', giving up
dpkg: error processing archive /var/cache/apt/archives/lua-cjson_2.1.0.10-jitsi1_amd64.deb (--unpack):
 dpkg-deb --control subprocess returned error exit status 2
Errors were encountered while processing:
 /var/cache/apt/archives/lua-basexx_0.4.1-jitsi1_all.deb
 /var/cache/apt/archives/lua-cjson_2.1.0.10-jitsi1_amd64.deb
E: Sub-process /usr/bin/dpkg returned an error code (1)
1 Like

lua-cjson is already in the Debian Bullseye official repo. Why do you need it from Jitsi repo?

Those packages we did because the orignals does not support lua 5.3 and 5.4.
The error should be fixed now, I dropped the packages from stable repo. Will re add them when this is fixed.

3 Likes

I just updated the packages in unstable and stable, should be fine now. This time I use Debian 11 for building them not Ubuntu :man_facepalming: Sorry for the trouble.

4 Likes

Confirm, works again. Thank you!

1 Like